//THIS FUNCTION WILL CREATE A THERMOMETER LIKE DISPLAY OF THE INPUT DATA
//
//var1: 1xn vector             --> data to be displayd
//var2: string                 --> data unit
//var3: string                 --> figure name
//var4: [1x2] matrix           --> figure position
//var5: integer                --> figure color
//var6: integer                --> display color
//var7: integer                --> the time pause [in milliseconds] after that the
//                                 next data point will be displayed.
function thermometer (data,unit,figname, figpos, figcolor, dispcolor, tstep)

CENTER = [0 0];
END    = max(size(data));

fignr = 1002;       // use big numbers, so normal figures won't be affected

f = figure(fignr);
delmenu(fignr,'Datei');
delmenu(fignr,'Zusatzprogramme');
delmenu(fignr,'Editieren');
delmenu(fignr,'?');
toolbar(fignr,'off');
f.background        = figcolor;
f.figure_size       = [5 300];
f.figure_name       = figname;
f.figure_position   = figpos;

// define the frame for the thermometer
rect=[-1,min(data),1,max(data)];
plot2d(0,0,0,rect=rect);     
a = gca();
a.visible = "on";
a.box = "off";
a.margins = [0.1,0.4,0.1,0.1];
a.axes_visible = ["off","on","off"];
a.x_location = "middle";
a.y_location = "right";
y_label = a.y_label;
y_label.text = unit;
a.y_label.font_angle = 0;
a.y_label.position = [1.25 max(data)];

a.foreground                = dispcolor;
a.font_foreground           = dispcolor;
a.y_label.font_foreground   = dispcolor;



plot(CENTER(1), CENTER(2),'ro');
e = gce();
p = e.children(1);  // get the point as a handle
p.mark_style = 1;
p.mark_size = 6;

// display actual temperature

for i=1:END;
    drawlater(); 
    if data(i) == 0 then;
        rect=[-0.5,data(i),1,abs(data(i))];
        xrect(rect);
        a = gca();
        a.axes_visible = ["off","on","off"];
        e = a.children(1);
        e.background = 1;
        e.thickness = 1;
    elseif data(i) > 0;
        rect=[-0.5,data(i),1,abs(data(i))];
        xfrect(rect);
        a = gca();
        a.axes_visible = ["off","on","off"];
        e = a.children(1);
        e.foreground = 5;
        e.background = 5;
        e.thickness = 3;
    else
        rect=[-0.5,0,1,abs(data(i))];
        xfrect(rect);
        a = gca();
        a.axes_visible = ["off","on","off"];
        e = a.children(1);
        e.foreground = 2;
        e.background = 2;
        e.thickness = 3;
    end        

    drawnow(); 
    xpause(tstep*1000);  // xpause counts in microseconds, tstep is for milliseconds, thatswhy factor 1000

    if  i < END
        delete(e);
    end
end

endfunction

clc;
temp = [0 -5 -10 -15 -25 -40 -10 -5 0 5 10 15 18 20 22 24 26 28 30 35 20 10 5 4 3 2 1 0];
thermometer (temp,'°C','thermometer',[500 300],1,7,50);
