//THIS FUNCTION WILL CREATE A VARIOMETER LIKE DISPLAY OF THE INPUT DATA
//
//var1: 1xn vector             --> data to be displayd
//var2: string                 --> data unit
//var3: string                 --> figure name
//var4: [1x2] matrix           --> figure position
//var5: integer                --> figure color
//var6: integer                --> display color
//var7: integer                --> the time pause [in milliseconds] after that the
//                                 next data point will be displayed.
function thermometer (data,unit,figname, figpos, figcolor, dispcolor, tstep)

CENTER = [0 0];
END    = max(size(data));

fignr = 1001;       // use big numbers, so normal figures won't be affected

f = figure(fignr);
delmenu(fignr,'Datei');
delmenu(fignr,'Zusatzprogramme');
delmenu(fignr,'Editieren');
delmenu(fignr,'?');
toolbar(fignr,'off');
f.background        = figcolor;
f.figure_size       = [5 300];
f.figure_name       = figname;
f.figure_position   = figpos;

// define the frame for the variometer

x = -1;
y = -10;
w = 1;
h = 10;

rect=[x,y,w,h];
plot2d(0,0,0,rect=rect);     
a = gca();  
a.visible = "on";
a.box = "off";
a.margins = [0.1,0.4,0.15,0.1];
a.axes_visible = ["off","on","off"];
a.x_location = "middle";
a.y_location = "right";
y_label = a.y_label;
y_label.text = unit;
a.y_label.font_angle = 0;
a.y_label.position = [1.25 12];

plot(CENTER(1), CENTER(2),'g+');
e = gce();
p = e.children(1);  // get the point as a handle
p.mark_style = 1;
p.mark_size = 6;

// display actual temperature

for i=1:END;
    drawlater(); 
    xpoly([-0.5 0.5],[data(i) data(i)],'lines',1);
    a = gca();
    a.axes_visible = ["off","on","off"];
    a.data_bounds = [x,y;w,h];
    e = a.children(1); 
    e.thickness = 3;  

    if data(i) < y*0.8 | data(i) > h*0.8;           // axes will turn red if data value exceeds 80% of scale
        a.foreground                = 5;
        a.font_foreground           = 5;
        a.y_label.font_foreground   = 5;
    else

        a.foreground                = dispcolor;
        a.font_foreground           = dispcolor;
        a.y_label.font_foreground   = dispcolor;
    end
 
    drawnow(); 
    xpause(tstep*1000);  // xpause counts in microseconds, tstep is for milliseconds, thatswhy factor 1000

    if  i < END
        delete(e);
    end
end

endfunction

clc;
temp = [0 -1 -2 -3 -4 -5 -6 -7 -7.5 -8 -8.5 -9 -9.5 -10 -8 -6 -4 -2 0 2 4 6 6.5 7 7.5 8 8.5 9 9.5 10 8 6 5 4 3 2 1 0];
thermometer (temp,'m/s','variometer',[700 300],1,7,50);
