//THIS FUNCTION WILL CREATE A WIND ROSE LIKE DISPLAY OF THE INPUT DATA
//
//var1: 1xn vector             --> data to be displayd
//var2: integer between 0-1    --> needle length
//var3: integer                --> needle thickness
//var4: integer                --> needle line style
//var5: [1x2] matrix           --> figure size
//var6: string                 --> figure name
//var7: [1x2] matrix           --> figure position
//var8: integer                --> figure color
//var9: integer               --> needle color
//var10: integer               --> the time pause [in milliseconds] after that the
//                                 next data point will be displayed.

exec('...\polarplot2.sci',-1)     // enter here the path variable to the function: polarplot2.sci

function windrose(data, needle_length, needle_thickness,needle_style, figsize, figname, figpos, color_fig, color_needle,tstep)

// create a new figure and delete all the menues and the toolbox                
fignr = 1004;       // use big numbers, so normal figures won't be affected

f = figure(fignr);
delmenu(fignr,'Datei');
delmenu(fignr,'Zusatzprogramme');
delmenu(fignr,'Editieren');
delmenu(fignr,'?');
toolbar(fignr,'off');
f.background = color_fig;
f.figure_size = figsize;
f.figure_name = figname;
f.figure_position = figpos;

END = max(size(heading));

// plot center point
drawlater();
plot2d(0,0,-9);
a = gca();
a.axes_visible = ["off","off","off"];
a.box = 'off';
// define the main angular grid
pts = [0:0.1:360];
frame = pts/180*%pi;
polarplot2(frame,1,1);                  // this is to get the main grid plotted, although the outer arc wil be plotted twice
a = gca();
a.axes_reverse = ["off","on","off"];
a.rotation_angles = [0,180];
a.thickness = 1;
// define the angular subgrid
subgrid = [0:5:360];
for j = 1:max(size(subgrid));
    L1 = 0.96
    L2 = 0.92
    if modulo(j,2) == 0;
      xpoly([L1 1] * (cos(subgrid(j)*%pi/180)), [L1 1]*(sin((subgrid(j))*%pi/180)),'lines',0);
    else
      xpoly([L2 1] * (cos(subgrid(j)*%pi/180)), [L2 1]*(sin((subgrid(j))*%pi/180)),'lines',0);
    end
    e = gce();
    e.line_style = 1;
    e.thickness  = 1;
end

// draw the needle
xset("color",color_needle);
for i=1:END;

    xpoly([0 cos((heading(i))*%pi/180)*needle_length],[0 sin((heading(i))*%pi/180)*needle_length],'lines',0);
    e = gce();
    e.line_style = 1;
    e.polyline_style = needle_style;
    e.thickness = needle_thickness;

    xpause(tstep*1000);  // xpause counts in microseconds, tstep is for milliseconds, thatswhy factor 1000

    if  i < END;
        delete(gce());
    end;
end;

endfunction;

// define the data values
heading = [0 10 20 40 60 80 100 120 140 160 180 200 220 240 260 280 300 320 340 350 355 358 359 300 240 200 160 120 80 40 20 0]; 
windrose(heading,0.8,2,4,[350;350],'wind rose',[200;200],3,5,50);

